//###############################################################
//# mask1_slots.h for ProcessViewServer created: Mo. Jan. 9 14:13:53 2023
//# please fill out these slots
//# here you find all possible events
//# Yours: Lehrig Software Engineering
//###############################################################
#include "rludpsocket.h"

// todo: uncomment me if you want to use this data aquisiton
// also uncomment this classes in main.cpp and pvapp.h
// also remember to uncomment rllib in the project file
//extern rlModbusClient     modbus;  //Change if applicable
//extern rlSiemensTCPClient siemensTCP;
//extern rlPPIClient        ppi;

typedef struct // (todo: define your data structure here)
{
  char OrderDeMufti[10];
}
DATA;

static int slotInit(PARAM *p, DATA *d)
{
  if(p == NULL || d == NULL) return -1;
  //memset(d,0,sizeof(DATA));
  strcpy(d->OrderDeMufti, "");
  return 0;
}

static int slotNullEvent(PARAM *p, DATA *d)
{
  if(p == NULL || d == NULL) return -1;
  return 0;
}

static int slotButtonEvent(PARAM *p, int id, const char *event, DATA *d)
{
  if(p == NULL || id == 0 || d == NULL) return -1;
  //printf("slotButtonEvent:id=%d event=%s\n", id, event);
  int zeile   = -1;
  int spalte3 = -1;
  int spalte4 = -1;
  const char *cptr = strstr(event,"-xy=");
  if(cptr != NULL)
  {
    int x,y;
    sscanf(cptr,"-xy=%d,%d",&x,&y);
    //printf("x=%d y=%d\n",x,y);
    // x ============================== 3 knoeppe pro zeile
    if(x<195)
    {
      //printf("x3 zu klein\n");
    }
    else if(x<244)
    {
      spalte3 = 1;
      //printf("x3 spalte %d\n", 1);
    }
    else if(x<291)
    {
      spalte3 = 2;
      //printf("x3 spalte %d\n", 2);
    }
    else if(x<343)
    {
      spalte3 = 3;
      //printf("x3 spalte %d\n", 3);
    }
    else
    {
      //printf("x3 zu gross\n");
    }
    // x ============================== 4 knoeppe pro zeile
    if(x<195)
    {
      //printf("x4 zu klein\n");
    }
    else if(x<235)
    {
      spalte4 = 1;
      //printf("x4 spalte %d\n", 1);
    }
    else if(x<271)
    {
      spalte4 = 2;
      //printf("x4 spalte %d\n", 2);
    }
    else if(x<307)
    {
      spalte4 = 3;
      //printf("x4 spalte %d\n", 3);
    }
    else if(x<343)
    {
      spalte4 = 4;
      //printf("x4 spalte %d\n", 4);
    }
    else
    {
      //printf("x4 zu gross\n");
    }
    // y ==============================
    if(y<170)
    {
      //printf("y zu klein\n");
    }
    else if(y<216)
    {
      zeile = 1;
      //printf("y zeile %d\n", 1);
    }
    else if(y<258)
    {
      zeile = 2;
      //printf("y zeile %d\n", 2);
    }
    else if(y<296)
    {
      zeile = 3;
      //printf("y zeile %d\n", 3);
    }
    else if(y<341)
    {
      zeile = 4;
      //printf("y zeile %d\n", 4);
    }
    else if(y<390)
    {
      zeile = 5;
      //printf("y zeile %d\n", 5);
    }
    else if(y<430)
    {
      zeile = 6;
      //printf("y zeile %d\n", 6);
    }
    else if(y<469)
    {
      zeile = 7;
      //printf("y zeile %d\n", 7);
    }
    else if(y<506)
    {
      zeile = 8;
      //printf("y zeile %d\n", 8);
    }
    else if(y<540)
    {
      zeile = 9;
      //printf("y zeile %d\n", 9);
    }
    else if(y<573)
    {
      zeile = 10;
      //printf("y zeile %d\n", 10);
    }
    else if(y<603)
    {
      zeile = 11;
      //printf("y zeile %d\n", 11);
    }
    else if(y<632)
    {
      zeile = 12;
      //printf("y zeile %d\n", 12);
    }
    else
    {
      //printf("y zu gross\n");
    }

    // ergebnis:
    printf("zeile=%d spalte3=%d spalte4=%d\n", zeile, spalte3, spalte4);

    // Sende UDP Botschaft an unseren Arbeiter
    rlUdpSocket udp;
    rlIpAdr dest;
    dest.setAdr("192.168.1.98", 1234);
    int ret = udp.printf(&dest, "%d %d %d %s\n", zeile, spalte3, spalte4, d->OrderDeMufti);
    printf("udp.printf ret=%d (StringLength)\n", ret);
  }
  return 0;
}

static int slotButtonPressedEvent(PARAM *p, int id, DATA *d)
{
  if(p == NULL || id == 0 || d == NULL) return -1;
  return 0;
}

static int slotButtonReleasedEvent(PARAM *p, int id, DATA *d)
{
  if(p == NULL || id == 0 || d == NULL) return -1;
  return 0;
}

static int slotTextEvent(PARAM *p, int id, DATA *d, const char *text)
{
  if(p == NULL || id == 0 || d == NULL || text == NULL) return -1;
  if(id == lineeditOrderDeMufti)
  {
    strncpy(d->OrderDeMufti, text, 8);
    d->OrderDeMufti[8] = '\0'; // bei 8 abschneiden
  }
  return 0;
}

static int slotSliderEvent(PARAM *p, int id, DATA *d, int val)
{
  if(p == NULL || id == 0 || d == NULL || val < -1000) return -1;
  return 0;
}

static int slotCheckboxEvent(PARAM *p, int id, DATA *d, const char *text)
{
  if(p == NULL || id == 0 || d == NULL || text == NULL) return -1;
  return 0;
}

static int slotRadioButtonEvent(PARAM *p, int id, DATA *d, const char *text)
{
  if(p == NULL || id == 0 || d == NULL || text == NULL) return -1;
  return 0;
}

static int slotGlInitializeEvent(PARAM *p, int id, DATA *d)
{
  if(p == NULL || id == 0 || d == NULL) return -1;
  return 0;
}

static int slotGlPaintEvent(PARAM *p, int id, DATA *d)
{
  if(p == NULL || id == 0 || d == NULL) return -1;
  return 0;
}

static int slotGlResizeEvent(PARAM *p, int id, DATA *d, int width, int height)
{
  if(p == NULL || id == 0 || d == NULL || width < 0 || height < 0) return -1;
  return 0;
}

static int slotGlIdleEvent(PARAM *p, int id, DATA *d)
{
  if(p == NULL || id == 0 || d == NULL) return -1;
  return 0;
}

static int slotTabEvent(PARAM *p, int id, DATA *d, int val)
{
  if(p == NULL || id == 0 || d == NULL || val < -1000) return -1;
  return 0;
}

static int slotTableTextEvent(PARAM *p, int id, DATA *d, int x, int y, const char *text)
{
  if(p == NULL || id == 0 || d == NULL || x < -1000 || y < -1000 || text == NULL) return -1;
  return 0;
}

static int slotTableClickedEvent(PARAM *p, int id, DATA *d, int x, int y, int button)
{
  if(p == NULL || id == 0 || d == NULL || x < -1000 || y < -1000 || button < 0) return -1;
  return 0;
}

static int slotSelectionEvent(PARAM *p, int id, DATA *d, int val, const char *text)
{
  if(p == NULL || id == 0 || d == NULL || val < -1000 || text == NULL) return -1;
  return 0;
}

static int slotClipboardEvent(PARAM *p, int id, DATA *d, int val)
{
  if(p == NULL || id == -1 || d == NULL || val < -1000) return -1;
  return 0;
}

static int slotRightMouseEvent(PARAM *p, int id, DATA *d, const char *text)
{
  if(p == NULL || id == 0 || d == NULL || text == NULL) return -1;
  //pvPopupMenu(p,-1,"Menu1,Menu2,,Menu3");
  return 0;
}

static int slotKeyboardEvent(PARAM *p, int id, DATA *d, int val, int modifier)
{
  if(p == NULL || id == 0 || d == NULL || val < -1000 || modifier < -1000) return -1;
  return 0;
}

static int slotMouseMovedEvent(PARAM *p, int id, DATA *d, float x, float y)
{
  if(p == NULL || id == 0 || d == NULL || x < -1000 || y < -1000) return -1;
  return 0;
}

static int slotMousePressedEvent(PARAM *p, int id, DATA *d, float x, float y)
{
  if(p == NULL || id == 0 || d == NULL || x < -1000 || y < -1000) return -1;
  return 0;
}

static int slotMouseReleasedEvent(PARAM *p, int id, DATA *d, float x, float y)
{
  if(p == NULL || id == 0 || d == NULL || x < -1000 || y < -1000) return -1;
  return 0;
}

static int slotMouseOverEvent(PARAM *p, int id, DATA *d, int enter)
{
  if(p == NULL || id == 0 || d == NULL || enter < -1000) return -1;
  return 0;
}

static int slotUserEvent(PARAM *p, int id, DATA *d, const char *text)
{
  if(p == NULL || id == 0 || d == NULL || text == NULL) return -1;
  return 0;
}
